package dev.shadowsoffire.apotheosis.advancements;

import java.util.Iterator;
import java.util.List;
import com.google.common.collect.Lists;
import com.google.common.collect.Sets;
import java.util.Set;
import net.minecraft.advancements.critereon.SerializationContext;
import net.minecraft.advancements.critereon.ContextAwarePredicate;
import net.minecraft.advancements.critereon.AbstractCriterionTriggerInstance;
import net.minecraft.advancements.CriterionTriggerInstance;
import net.minecraft.world.item.ItemStack;
import net.minecraft.server.level.ServerPlayer;
import dev.shadowsoffire.apotheosis.adventure.loot.RarityRegistry;
import net.minecraft.util.GsonHelper;
import net.minecraft.advancements.critereon.ItemPredicate;
import net.minecraft.advancements.critereon.DeserializationContext;
import com.google.gson.JsonObject;
import com.google.common.collect.Maps;
import net.minecraft.server.PlayerAdvancements;
import java.util.Map;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.advancements.CriterionTrigger;

public class GemCutTrigger implements CriterionTrigger<Instance>
{
    private static final ResourceLocation ID;
    private final Map<PlayerAdvancements, Listeners> listeners;
    
    public GemCutTrigger() {
        this.listeners = Maps.newHashMap();
    }
    
    public ResourceLocation m_7295_() {
        return GemCutTrigger.ID;
    }
    
    public void m_6467_(final PlayerAdvancements playerAdvancementsIn, final CriterionTrigger.Listener<Instance> listener) {
        Listeners ModifierTrigger$listeners = this.listeners.get(playerAdvancementsIn);
        if (ModifierTrigger$listeners == null) {
            ModifierTrigger$listeners = new Listeners(playerAdvancementsIn);
            this.listeners.put(playerAdvancementsIn, ModifierTrigger$listeners);
        }
        ModifierTrigger$listeners.add(listener);
    }
    
    public void m_6468_(final PlayerAdvancements playerAdvancementsIn, final CriterionTrigger.Listener<Instance> listener) {
        final Listeners ModifierTrigger$listeners = this.listeners.get(playerAdvancementsIn);
        if (ModifierTrigger$listeners != null) {
            ModifierTrigger$listeners.remove(listener);
            if (ModifierTrigger$listeners.isEmpty()) {
                this.listeners.remove(playerAdvancementsIn);
            }
        }
    }
    
    public void m_5656_(final PlayerAdvancements playerAdvancementsIn) {
        this.listeners.remove(playerAdvancementsIn);
    }
    
    public Instance createInstance(JsonObject json, final DeserializationContext conditionsParser) {
        json = json.getAsJsonObject("conditions");
        if (json != null) {
            final ItemPredicate item = ItemPredicate.m_45051_(json.get("item"));
            final ResourceLocation rarity = RarityRegistry.convertId(GsonHelper.m_13851_(json, "rarity", ""));
            return new Instance(item, rarity);
        }
        return new Instance(ItemPredicate.f_45028_, new ResourceLocation(""));
    }
    
    public void trigger(final ServerPlayer player, final ItemStack stack, final ResourceLocation rarity) {
        final Listeners ModifierTrigger$listeners = this.listeners.get(player.m_8960_());
        if (ModifierTrigger$listeners != null) {
            ModifierTrigger$listeners.trigger(stack, rarity);
        }
    }
    
    static {
        ID = new ResourceLocation("apotheosis", "gem_cutting");
    }
    
    public static class Instance extends AbstractCriterionTriggerInstance
    {
        private final ItemPredicate gem;
        private final ResourceLocation rarity;
        
        public Instance(final ItemPredicate gem, final ResourceLocation rarity) {
            super(GemCutTrigger.ID, ContextAwarePredicate.f_285567_);
            this.gem = gem;
            this.rarity = rarity;
        }
        
        public JsonObject m_7683_(final SerializationContext serializer) {
            return new JsonObject();
        }
        
        public boolean test(final ItemStack stack, final ResourceLocation rarity) {
            return this.gem.m_45049_(stack) && (this.rarity.m_135815_().isEmpty() || this.rarity.equals((Object)rarity));
        }
    }
    
    static class Listeners
    {
        private final PlayerAdvancements playerAdvancements;
        private final Set<CriterionTrigger.Listener<Instance>> listeners;
        
        public Listeners(final PlayerAdvancements playerAdvancementsIn) {
            this.listeners = Sets.newHashSet();
            this.playerAdvancements = playerAdvancementsIn;
        }
        
        public boolean isEmpty() {
            return this.listeners.isEmpty();
        }
        
        public void add(final CriterionTrigger.Listener<Instance> listener) {
            this.listeners.add(listener);
        }
        
        public void remove(final CriterionTrigger.Listener<Instance> listener) {
            this.listeners.remove(listener);
        }
        
        public void trigger(final ItemStack stack, final ResourceLocation rarity) {
            List<CriterionTrigger.Listener<Instance>> list = null;
            for (final CriterionTrigger.Listener<Instance> listener : this.listeners) {
                if (((Instance)listener.m_13685_()).test(stack, rarity)) {
                    if (list == null) {
                        list = Lists.newArrayList();
                    }
                    list.add(listener);
                }
            }
            if (list != null) {
                for (final CriterionTrigger.Listener<Instance> listener2 : list) {
                    listener2.m_13686_(this.playerAdvancements);
                }
            }
        }
    }
}
